#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>

#include "DSIHE.h"

#ifndef L
#define L 256
#endif

DSIHE::DSIHE(char *file,int bEHE) : Equalization(file,bEHE,AL_DSIHE)
{
}

void DSIHE::Equalizing()
{
	int area;
	register int l;

	/* Half Area calculation */
	area = 0;
	for ( l = 0 ; l < L ; l++ )
	{
		if ( area > (int)(m_iPixels/2.) )
			break;
		area += m_pH[l];
	}

	HistEq(0,l-1);
	HistEq(l,L-1);

	Equalization::Equalizing();
}

const char* DSIHE::GetAlgorithm()
{
	return "DSIHE";
}
