#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>

#include "BBHE.h"

#ifndef L
#define L 256
#endif

BBHE::BBHE(char *file,int bEHE) : Equalization(file,bEHE,AL_BBHE)
{
}

void BBHE::Equalizing()
{
	double mean;
	register int l;

	/* Mean calculation */
	mean = 0.;
	for ( l = 0 ; l < L ; l++ )
		mean += l * m_pH[l];
	mean /= m_iPixels;

	HistEq(0,(int)mean);
	HistEq((int)mean+1,L-1);

	Equalization::Equalizing();
}

const char* BBHE::GetAlgorithm()
{
	return "BBHE";
}
